from machine import Pin
import time
import ws2812b

LED_NUM = 288                               # Nombre de Neopixels sur le ruban
DIN_GPIO = 0                                # GPIO sur lequel le ruban est connecté

rouge = 255, 0, 0
vert = 0, 255, 0
bleu = 0, 0, 255
jaune = 255, 255, 0
cyan = 0, 255, 255
magenta = 255, 0, 255
blanc = 255, 255, 255
noir = 0, 0, 0

# création de l'instance du ruban
strip = ws2812b.ws2812b(LED_NUM, 0, DIN_GPIO)

def wheel(pos):
    # Les couleurs ont une valeur de 0 à 255
    # et sont une transition entre rouge, vert et bleu
    if pos < 0 or pos > 255:
        r = g = b = 0
    elif pos < 85:
        r = int(pos * 3)
        g = int(255 - pos * 3)
        b = 0
    elif pos < 170:
        pos -= 85
        r = int(255 - pos * 3)
        g = 0
        b = int(pos * 3)
    else:
        pos -= 170
        r = 0
        g = int(pos * 3)
        b = int(255 - pos * 3)
    
    return r, g, b


def rainbow_cycle(wait):
    for j in range(255):
        for i in range(LED_NUM):
            pixel_index = (i * 256 // LED_NUM) + j
            r, v, b = wheel(pixel_index & 255)
            strip.set_pixel(i, r, v, b)
        strip.show()
        time.sleep(wait)

while True:
    # LEDs rouges
    r,v,b = rouge
    strip.fill (r, v, b)
    strip.show()
    time.sleep(0.5)

    # LEDs vertes
    r,v,b = vert
    strip.fill (r, v, b)
    strip.show()
    time.sleep(0.5)

    # LEDs bleues
    r,v,b = bleu
    strip.fill (r, v, b)
    strip.show()
    time.sleep(0.5)
    
    # LEDs cyan
    r,v,b = cyan
    strip.fill (r, v, b)
    strip.show()
    time.sleep(0.5)

    # LEDs jaune
    r,v,b = jaune
    strip.fill (r, v, b)
    strip.show()
    time.sleep(0.5)

    # LEDs magenta
    r,v,b = magenta
    strip.fill (r, v, b)
    strip.show()
    time.sleep(0.5)

    # LEDs blanches
    r,v,b = blanc
    strip.fill (r, v, b)
    strip.show()
    time.sleep(0.5)

    # LEDs éteintes
    r,v,b = noir
    strip.fill (r, v, b)
    strip.show()
    time.sleep(1)

    rainbow_cycle(0.001)  # Boucle affichant un arc en ciel - Attente 1 ms
